unit dwsIsapiModule;

interface

uses
  Windows, Messages, SysUtils, Classes, HTTPApp, dwsDemoLib, dwsComp,
  dwsUtilsLib, dwsErrors, dwsISAPILib, dwsPageProducer,
  dwsFilesLib;

type
  TIsapiModule = class(TWebModule)
    script: TDelphiWebScript;
    dwsUtilsLib: TdwsUtilsLib;
    DwsISAPILib: TDwsISAPILib;
    dwsPageProducer1: TdwsPageProducer;
    procedure IsapiModuledefaultAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure DwsISAPILibCustomCommand(dwsScript: TDelphiWebScript;
      dwsLib: TDwsISAPILib);
    procedure DwsISAPILibEvalIsapi(Sender: TObject; scr: TDelphiWebScript;
      pat: Integer; args: TArgList; var Result: Variant);
  private
    { Private-Deklarationen }
    function ExecuteScript (s : string) : string;
  public
    { Public-Deklarationen }
  end;

var
  IsapiModule: TIsapiModule;

implementation

{$R *.DFM}

function TIsapiModule.ExecuteScript(s: string) : string;
var 
  start, count : Integer;
begin
  script.Text := s;
  result := '';
  start := 0;
  count := 0;
  try
    script.Execute;
    result := script.Result;
  except
    on e : EScriptError do 
      result := '<html><body>' + 
      '<p>' + e.Message + '</p>' +
      '<p>' + GetErrorLine (e.ePos, start, count) + '</p>' +
      '</body></html>';
    on e : Exception do
      result := '<html><body>' + 
      '<p>' + e.Message + '</p>' +
      '</body></html>';
  end;
end;

procedure TIsapiModule.IsapiModuledefaultAction(Sender: TObject; Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
const
  RootDir = 'c:\';
var
  fs : TFileStream;
  ss : TStringStream;
  f : string;
begin
  DwsISAPILib.initISAPIsession(request,response);
  f := Request.PathTranslated;
  try
    fs := TFileStream.Create( f, fmOpenRead + fmShareDenyWrite);

    try
      ss := TStringStream.Create ('');

      try
        ss.CopyFrom (fs, fs.Size);
        ss.Position := 0;

        Response.Content := ExecuteScript (ss.DataString);
      finally
        ss.Free;
      end;
    finally
      fs.Free;
    end;
  except
    Response.Content := '<html><body><p>DWS-Error: File ' +
       f + ' not found or invalid!</p></body></html>';
  end;
end;

procedure TIsapiModule.DwsISAPILibCustomCommand(
  dwsScript: TDelphiWebScript; dwsLib: TDwsISAPILib);
begin
  if dwsLib.CustomCommand='action' then          // debugging only
    dwsLib.FactUser.SState := dwstatePRF;
end;

procedure TIsapiModule.DwsISAPILibEvalIsapi(Sender: TObject;
  scr: TDelphiWebScript; pat: Integer; args: TArgList;
  var Result: Variant);
begin
  inc((sender as TdwsISAPILib).FactUser.UScore); // debugging only
end;

end.
